/* Step 1  Print as "Hello JavaPOS"*/
//A string is sent by using the method "printNormal", and it is printed.

package net.jpos.tools.test;

import jpos.*;
import jpos.events.*;
import jpos.util.JposPropertiesConst;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.awt.event.WindowEvent;
import java.io.InputStream;
import java.util.Properties;

public class JposPrinterTest extends JFrame implements StatusUpdateListener,
        OutputCompleteListener, ErrorListener {

    public static void main(String[] args) {
        try {
            UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (args.length < 2) {
            throw new RuntimeException("JposPrinterTest args Error!");
        }
        JposPrinterTest frame = new JposPrinterTest(args[0], args[1]);
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }


    POSPrinterControl114 ptr = new POSPrinter();

    JPanel contentPane;
    JPanel jPanel_reciept = new JPanel();
    TitledBorder titledBorder1;
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    JButton jButton_Print = new JButton();
    JTextArea tipsArea = new JTextArea();
    private String logicName;

    /**
     * Constract "Frame"
     */
    public JposPrinterTest(String xmlFile, String logicName) {
        this.logicName = logicName;
        System.setProperty(JposPropertiesConst.JPOS_POPULATOR_FILE_PROP_NAME, xmlFile);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Form the component
     */
    private void jbInit() {
        contentPane = (JPanel) this.getContentPane();
        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(134, 134, 134)), "Receipt");
        contentPane.setLayout(gridBagLayout1);
        this.setSize(new Dimension(700, 280));
        this.setTitle("Hello JavaPOS");
        jPanel_reciept.setLayout(gridBagLayout2);
        jPanel_reciept.setBorder(titledBorder1);
        jButton_Print.setText("Sample Receipt");
        jButton_Print.addActionListener(e -> sampleReceiptClick());
        JButton imageBtn = new JButton();
        imageBtn.setText("Image");
        imageBtn.addActionListener(e -> imageClick());
        JButton barcodeBtn = new JButton();
        barcodeBtn.setText("Barcode");
        barcodeBtn.addActionListener(e -> barcodeClick());
        JButton cutterBtn = new JButton();
        cutterBtn.setText("Cut Paper");
        cutterBtn.addActionListener(e -> cutPaperClick());
        JButton beeperBtn = new JButton();
        beeperBtn.setText("DirectIO Beeper");
        beeperBtn.addActionListener(e -> beeperClick());
        JScrollPane scrollPane = new JScrollPane();
        scrollPane.setBounds(10, 10, 10, 10);
        scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER); // 禁用水平滚动条
        tipsArea.setLineWrap(true);
        scrollPane.setViewportView(tipsArea);
        contentPane.add(jPanel_reciept, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(15, 0, 0, 0), 20, 20));
        jPanel_reciept.add(jButton_Print, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 10), 80, 0));
        jPanel_reciept.add(barcodeBtn, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 10), 80, 0));
        jPanel_reciept.add(imageBtn, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 10), 80, 0));
        jPanel_reciept.add(cutterBtn, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 10), 80, 0));
        jPanel_reciept.add(beeperBtn, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
                , GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 10), 80, 0));
        contentPane.add(scrollPane, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(15, 0, 0, 0), 300, 193));
    }

    protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            this.closing();
        } else if (e.getID() == WindowEvent.WINDOW_OPENED) {
            try {
                ptr.addStatusUpdateListener(this);
                ptr.addErrorListener(this);
                ptr.addOutputCompleteListener(this);

//                ptr.open("JposPrinter_ethernet");
                ptr.open(logicName);
                ptr.claim(1000);
                ptr.setPowerNotify(JposConst.JPOS_PN_ENABLED);
                ptr.setDeviceEnabled(true);
                ptr.setAsyncMode(true);
            } catch (JposException ex) {
                ex.printStackTrace();
                addMsg(ex.getMessage());
            }
        }
        // JavaPOS's code for Step1--END
    }

    //***********************Button*************************************************
    private void sampleReceiptClick() {
        try {
            ptr.transactionPrint(POSPrinterConst.PTR_S_RECEIPT, POSPrinterConst.PTR_TP_TRANSACTION);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "\u001b|N\u001b|cA\u001b|2CLas vegas,NV5208\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "\u001B|N\u001b|1uF");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "Ticket #30-57320                User:HAPPY\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "Station:52-102             Sales Rep HAPPY\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "10/10/2024 3:55:01PM\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "------------------------------------------\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "Item         QTY       Price         Total\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "Description\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "------------------------------------------\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "100328        1         7.99          7.99\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "MAGARITA MIX\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "680015        4         0.99          3.96\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "LIME\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "102501        1        43.99         43.99\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "VODKA\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "021048        1         4.99          4.99\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "ORANGE 320Z\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "------------------------------------------\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "Subtobal                             60.93\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "8.1% Sales Tax                        4.21\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "2% Concession Recov                   1.04\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "------------------------------------------\n");
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "Total                                66.18\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "B123456789", POSPrinterConst.PTR_BCS_Code128, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_NONE);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "\u001B|N\u001b|50fP");
            ptr.transactionPrint(POSPrinterConst.PTR_S_RECEIPT, POSPrinterConst.PTR_TP_NORMAL);

        } catch (JposException e) {
            e.printStackTrace();
        }
    }

    private void barcodeClick() {
        Properties properties = new Properties();
        InputStream input = JposPrinterTest.class.getClassLoader().getResourceAsStream("sample.properties");
        String qrData = "POSPrinter(C)2024-4C6565";
        try {
            properties.load(input);
            qrData = properties.getProperty("qrdata");
            if (qrData == null) {
                qrData = "POSPrinter(C)2024-4C6565";
            }else {
                qrData = qrData.trim();
            }
        } catch (Exception e) {
            e.printStackTrace();
            //throw new RuntimeException(e);
        }
        try {
            ptr.transactionPrint(POSPrinterConst.PTR_S_RECEIPT, POSPrinterConst.PTR_TP_TRANSACTION);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "UPC-A\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "01234567890", POSPrinterConst.PTR_BCS_UPCA, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "UPC-E\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "01234567890", POSPrinterConst.PTR_BCS_UPCE, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "EAN-13\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "012345678901", POSPrinterConst.PTR_BCS_EAN13, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "EAN-8\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "0123456", POSPrinterConst.PTR_BCS_EAN8, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "CODE39\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "01234567", POSPrinterConst.PTR_BCS_Code39, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "ITF\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "01234567890", POSPrinterConst.PTR_BCS_ITF, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "CODABAR\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "B123456789B", POSPrinterConst.PTR_BCS_Codabar, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "CODE93\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "0123456789", POSPrinterConst.PTR_BCS_Code93, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "CODE128\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "{A0123456789", POSPrinterConst.PTR_BCS_Code128, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "PDF417\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "\u001B\u0003\u0003\u0006\u0003\u0030\u0032\u0001POSPrinter(C)2022-4C6565", POSPrinterConst.PTR_BCS_PDF417, 100,
                    ptr.getRecLineWidth(), POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "QRCODE\n");
            ptr.printBarCode(POSPrinterConst.PTR_S_RECEIPT, "\u001B\u0008\u0030"+ qrData, POSPrinterConst.PTR_BCS_QRCODE, 200,
                    200, POSPrinterConst.PTR_BC_CENTER, POSPrinterConst.PTR_BC_TEXT_BELOW);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "\u001B|N\u001b|50fP");
            ptr.transactionPrint(POSPrinterConst.PTR_S_RECEIPT, POSPrinterConst.PTR_TP_NORMAL);
        } catch (JposException e) {
            e.printStackTrace();
        }
    }

    private void imageClick() {
        try {
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "\u001b|N\u001b|cA\u001b|2CLogo\n");
            ptr.printBitmap(POSPrinterConst.PTR_S_RECEIPT, "image.bmp", 500, POSPrinterConst.PTR_BM_CENTER);
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "\u001B|N\u001b|50fP");
        } catch (JposException e) {
            e.printStackTrace();
        }
    }

    public void beeperClick() {
        try {
            byte[] b = {0x1B, 0x42, 0x04, 0x02, 0x00, 0x00};
            ptr.directIO(1000, null, b);
        } catch (JposException e) {
            throw new RuntimeException(e);
        }
    }

    private void cutPaperClick() {
        try {
            ptr.printNormal(POSPrinterConst.PTR_S_RECEIPT, "\n\n\n\n\n\n\n");
            ptr.cutPaper(100);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    //***********************Method*************************************************

    /**
     * Outline     The code to finish a service.
     */
    void closing() {
        // JavaPOS's code for Step1
        try {
            //Cancel the device.
            ptr.setDeviceEnabled(false);

            //Release the device exclusive control right.
            ptr.release();

            //Finish using the device.
            ptr.close();
        } catch (JposException ex) {
        }
        // JavaPOS's code for
        System.exit(0);
    }

    private void addMsg(String msg) {
        tipsArea.insert(msg + "\n", 0);
    }

    @Override
    public void errorOccurred(ErrorEvent errorEvent) {
        addMsg("ErrorEvent Code:" + errorEvent.getErrorCode());
    }

    @Override
    public void outputCompleteOccurred(OutputCompleteEvent outputCompleteEvent) {
        //addMsg("OutputCompleteEvent id:" + outputCompleteEvent.getOutputID());
    }

    @Override
    public void statusUpdateOccurred(StatusUpdateEvent statusUpdateEvent) {
        String msg;
        switch (statusUpdateEvent.getStatus()) {
            case POSPrinterConst.PTR_SUE_COVER_OPEN:
                msg = "PTR_SUE_COVER_OPEN";
                break;
            case POSPrinterConst.PTR_SUE_COVER_OK:
                msg = "PTR_SUE_COVER_OK";
                break;
            case POSPrinterConst.PTR_SUE_REC_EMPTY:
                msg = "PTR_SUE_REC_EMPTY";
                break;
            case POSPrinterConst.PTR_SUE_REC_NEAREMPTY:
                msg = "PTR_SUE_REC_NEAREMPTY";
                break;
            case POSPrinterConst.PTR_SUE_REC_PAPEROK:
                msg = "PTR_SUE_REC_PAPEROK";
                break;
            case JposConst.JPOS_PS_ONLINE:
                msg = "JPOS_PS_ONLINE";
                break;
            case JposConst.JPOS_PS_OFF:
                msg = "JPOS_PS_OFF";
                break;
            case JposConst.JPOS_PS_OFFLINE:
                msg = "JPOS_PS_OFFLINE";
                break;
            default:
                msg = "Status:" + statusUpdateEvent.getStatus();
                break;
        }

        addMsg("StatusUpdateEvent->" + msg);
    }
}
